#include "Spielfeld.h"
#include <sstream>
#include <string>

Spielfeld::Spielfeld(void)
{
}


Spielfeld::~Spielfeld(void)
{
}

void Spielfeld::anzeigen(std::ostream& s)
{
	std::string O = "O";
	std::string X = "X";

	std::string feldzeichen[9];
	
	Feld::Zustand z;

	for(int i = 0; i < 9; ++i)
	{
		z = _Felder[i].GetZustand();

		if(z == Feld::ANGEKREUZT)
		{
			feldzeichen[i] = X;
		} 
		else
		{
			if(z == Feld::ANGEKREIST)
			{
				feldzeichen[i] = O;
			}
			else
			{
				std::stringstream ss;
				ss << i;
				feldzeichen[i] = ss.str();
			}
		}
	}

	s << feldzeichen[0] << " | " << feldzeichen[1] << " | " << feldzeichen[2] << "\n";
	s << "---------" << "\n";
	s << feldzeichen[3] << " | " << feldzeichen[4] << " | " << feldzeichen[5] << "\n";
	s << "---------" << "\n";
	s << feldzeichen[6] << " | " << feldzeichen[7] << " | " << feldzeichen[8] << "\n";
	s.flush();
}

Feld::Zustand Spielfeld::GetFeldZustand(Feldnummer n)
{
	return _Felder[n].GetZustand();
}

void Spielfeld::SetFeldZustand(Feldnummer n, Feld::Zustand z)
{
	_Felder[n].SetZustand(z);
}

void Spielfeld::GetFreieFelder(Feldnummer freiefelder[], int& anzahl)
{
	Feldnummer tmp[9];
	int tmpint = 0;

	for(int i = 0; i < 9; ++i)
	{
		if(_Felder[i].GetZustand() == Feld::FREI)
		{
			tmp[tmpint] = (Feldnummer)i;
			++tmpint;
		}
	}

	anzahl = tmpint;
	for(int i = 0; i < anzahl; ++i)
	{
		freiefelder[i] = tmp[i];
	}
}