#include "TicTacToe.h"


TicTacToe::TicTacToe(std::ostream& ausgabestream, std::istream& eingabestream) : _Ausgabestream(ausgabestream), _Eingabestream(eingabestream)
{
}


TicTacToe::~TicTacToe(void)
{
}

void TicTacToe::Start()
{
	_Gewinner = -1;

	GetSpieler();
	
	do
	{
		Spiel();
	}
	while(Weiter());
	
	ZeigeGewinnerAn();
}

void TicTacToe::GetSpieler()
{
	std::string name;

	_Ausgabestream << "TicTacToe" << std::endl;
	_Ausgabestream << std::endl;
	_Ausgabestream << "Spieler 1 bitte Name eigeben:" << std::endl;
	_Eingabestream >> name;
	_Spieler[0].SetName(name);
	_Ausgabestream << "Spieler 2 bitte Name eigeben:" << std::endl;
	_Eingabestream >> name;
	_Spieler[1].SetName(name);
	_Ausgabestream << std::endl;
}

void TicTacToe::Spiel()
{
	system("cls");

	int aktiverSpieler = 3;
	Feld::Zustand zeichen;
	
	if(_Gewinner == -1)
	{
		aktiverSpieler = 0;
		zeichen = Feld::ANGEKREUZT;
	} 
	else
	{
		if(_Gewinner == 0)
		{
			aktiverSpieler = 1;
			zeichen = Feld::ANGEKREIST;
		}
		else
		{
			aktiverSpieler = 0;
			zeichen = Feld::ANGEKREUZT;
		}
	}


	_Ausgabestream << "Spieler 1 : " << _Spieler[0].GetName() << " du hast X" << std::endl;
	_Ausgabestream << "Spieler 2 : " << _Spieler[1].GetName() << " du hast O" << std::endl;
	_Ausgabestream << std::endl;
	_Ausgabestream << _Spieler[aktiverSpieler].GetName() << " bitte waehle ein Feld." << std::endl;
	_Ausgabestream << std::endl;
	_Spielfeld.anzeigen(_Ausgabestream);
	_Ausgabestream << std::endl;
	_Ausgabestream << "Die freien Felder sind:" << std::endl;

	Spielfeld::Feldnummer freiefelder[9];
	int anzahl = 0;
	_Spielfeld.GetFreieFelder(freiefelder, anzahl);

	for(int i = 0; i < anzahl; ++i)
	{
		_Ausgabestream << freiefelder[i] << std::endl;
	}

	_Ausgabestream << std::endl;

	int feldnummer = -1;
	_Ausgabestream << "du waehlst das Feld nummer: ";
	_Ausgabestream.flush();
	_Eingabestream >> feldnummer;

	_Spielfeld.SetFeldZustand((Spielfeld::Feldnummer)feldnummer, zeichen);

	_Gewinner = aktiverSpieler;
}

bool TicTacToe::Weiter()
{
	bool b = true;

	Feld::Zustand zustnde[9];
	for(int i = 0; i < 9; ++i)
	{
		zustnde[i] = _Spielfeld.GetFeldZustand((Spielfeld::Feldnummer)i);
	}

	if( ( (zustnde[0] == Feld::ANGEKREUZT) && (zustnde[1] == Feld::ANGEKREUZT) && (zustnde[2] == Feld::ANGEKREUZT) ) || ( (zustnde[0] == Feld::ANGEKREIST) && (zustnde[1] == Feld::ANGEKREIST) && (zustnde[2] == Feld::ANGEKREIST) ) )
	{
		b = false;
	} 
	else
	{
		if( ( (zustnde[3] == Feld::ANGEKREUZT) && (zustnde[4] == Feld::ANGEKREUZT) && (zustnde[5] == Feld::ANGEKREUZT) ) || ( (zustnde[3] == Feld::ANGEKREIST) && (zustnde[4] == Feld::ANGEKREIST) && (zustnde[5] == Feld::ANGEKREIST) ) )
		{
			b = false;
		}
		else
		{
			if( ( (zustnde[6] == Feld::ANGEKREUZT) && (zustnde[7] == Feld::ANGEKREUZT) && (zustnde[8] == Feld::ANGEKREUZT) ) || ( (zustnde[6] == Feld::ANGEKREIST) && (zustnde[7] == Feld::ANGEKREIST) && (zustnde[8] == Feld::ANGEKREIST) ) )
			{
				b = false;
			}
			else
			{
				if( ( (zustnde[0] == Feld::ANGEKREUZT) && (zustnde[3] == Feld::ANGEKREUZT) && (zustnde[6] == Feld::ANGEKREUZT) ) || ( (zustnde[0] == Feld::ANGEKREIST) && (zustnde[3] == Feld::ANGEKREIST) && (zustnde[6] == Feld::ANGEKREIST) ) )
				{
					b = false;
				}
				else
				{
					if( ( (zustnde[1] == Feld::ANGEKREUZT) && (zustnde[4] == Feld::ANGEKREUZT) && (zustnde[7] == Feld::ANGEKREUZT) ) || ( (zustnde[1] == Feld::ANGEKREIST) && (zustnde[4] == Feld::ANGEKREIST) && (zustnde[7] == Feld::ANGEKREIST) ) )
					{
						b = false;
					}
					else
					{
						if( ( (zustnde[2] == Feld::ANGEKREUZT) && (zustnde[5] == Feld::ANGEKREUZT) && (zustnde[8] == Feld::ANGEKREUZT) ) || ( (zustnde[2] == Feld::ANGEKREIST) && (zustnde[5] == Feld::ANGEKREIST) && (zustnde[8] == Feld::ANGEKREIST) ) )
						{
							b = false;
						}
						else
						{
							if( ( (zustnde[0] == Feld::ANGEKREUZT) && (zustnde[4] == Feld::ANGEKREUZT) && (zustnde[8] == Feld::ANGEKREUZT) ) || ( (zustnde[0] == Feld::ANGEKREIST) && (zustnde[4] == Feld::ANGEKREIST) && (zustnde[8] == Feld::ANGEKREIST) ) )
							{
								b = false;
							}
							else
							{
								if( ( (zustnde[2] == Feld::ANGEKREUZT) && (zustnde[4] == Feld::ANGEKREUZT) && (zustnde[6] == Feld::ANGEKREUZT) ) || ( (zustnde[2] == Feld::ANGEKREIST) && (zustnde[4] == Feld::ANGEKREIST) && (zustnde[6] == Feld::ANGEKREIST) ) )
								{
									b = false;
								}
							}
						}
					}
				}
			}
		}
	}

	int zhler = 0;
	for(int i = 0; i < 9; ++i)
	{
		if(zustnde[i] == Feld::FREI) 
			++zhler;
	}

	if(zhler == 0)
	{
		_Gewinner = -1;
		b = false;
	}

	return b;
}

void TicTacToe::ZeigeGewinnerAn()
{
	system("cls");
	_Spielfeld.anzeigen(_Ausgabestream);
	_Ausgabestream << std::endl;
	if(_Gewinner == -1)
	{
		_Ausgabestream << "Es gibt keinen Gewinner !" << std::endl;
	}
	else
	{
		_Ausgabestream << "Der Gewinner ist " << _Spieler[_Gewinner].GetName() << std::endl;
	}
	_Ausgabestream << std::endl;
	system("Pause");
}