#pragma once

#include <iostream>
#include "Spielfeld.h"
#include "Spieler.h"

class TicTacToe
{
public:
						TicTacToe(std::ostream& ausgabestream, std::istream& eingabestream);
						~TicTacToe(void);
						void Start();

private:
	std::ostream&		_Ausgabestream;
	std::istream&		_Eingabestream;
	Spielfeld			_Spielfeld;
	Spieler				_Spieler[2];
	int					_Gewinner;

	void				GetSpieler();
	void				Spiel();
	bool				Weiter();
	void				ZeigeGewinnerAn();
};

