#include "Spieler.h"

#include <sstream>

int Spieler::_StaticCounter = 0;

Spieler::Spieler(void)
{
	_ID = _StaticCounter++;

	std::stringstream ss;
	ss << _ID;
	_Name = "unnamed" + ss.str();
}

Spieler::Spieler(std::string& name)
{
	_Name = name;
	_ID = _StaticCounter++;
}

Spieler::~Spieler(void)
{
}

void Spieler::SetName(std::string& neuername)
{
	_Name = neuername;
}

const std::string& Spieler::GetName(void)
{
	return _Name;
}

int Spieler::GetID(void)
{
	return _ID;
}
