#pragma once
#include <iostream>
#include "Feld.h"

// 0 | 1 | 2
// ---------
// 3 | 4 | 5
// ---------
// 6 | 7 | 8
class Spielfeld
{
public:

	enum Feldnummer { NUL, EINS, ZWEI, DREI, VIER, FUENF, SECHS, SIEBEN, ACHT };

					Spielfeld(void);
					~Spielfeld(void);
	
	void			anzeigen(std::ostream& s);

	Feld::Zustand	GetFeldZustand(Feldnummer n);
	void			SetFeldZustand(Feldnummer n, Feld::Zustand z);
	void			GetFreieFelder(Feldnummer freiefelder[], int& anzahl);

private:
	Feld			_Felder[9];
};

